#![cfg_attr(not(test), no_main)]
#![no_std]

#[cfg(not(test))]
extern crate panic_halt;

#[cfg(not(test))]
use cortex_m_rt::entry;
use hal::{pac, prelude::*, rcc::Config};

#[cfg(not(test))]
#[entry]
fn main() -> ! {
    let dp = pac::Peripherals::take().unwrap();
    let cp = cortex_m::Peripherals::take().unwrap();

    // Configure the clock.
    let mut rcc = dp.RCC.freeze(Config::hsi16());

    // Acquire the GPIOA peripheral. This also enables the clock for GPIOA in
    // the RCC register.
    let gpioa = dp.GPIOA.split(&mut rcc);

    // Configure PA5 as output.
    let mut led = gpioa.pa5.into_push_pull_output();

    // Get the delay provider.
    let mut delay = cp.SYST.delay(rcc.clocks);

    loop {
        led.set_high().unwrap();
        delay.delay_ms(500_u16);

        led.set_low().unwrap();
        delay.delay_ms(500_u16);
    }
}

#[cfg(test)]
fn main() -> ! {
    loop {}
}

#[cfg(test)]
mod tests {

    #[test]
    fn test_it_works() {
        assert!(true)
    }
}
